const path = require('path');
const MiniCssExtractPlugin = require('mini-css-extract-plugin');
const entry = require('webpack-glob-entry')
const FixStyleOnlyEntriesPlugin = require("webpack-fix-style-only-entries");
const {getFile,fileArr} = require('./readFile');

getFile('./src')

const baseConfig = {
    module : {
        rules: [
            {
                test: /\.scss$/,
                use: [
                    MiniCssExtractPlugin.loader,
                    'css-loader',
                    'sass-loader'
                ]
            }
        ]
    },
    output: {
        path: path.resolve(__dirname, './'),
    },
}

var useArr = []


//暂时没想到好的办法处理异步递归完成的时间问题，延时5s进行打包
module.exports = new Promise((resolve,reject)=>{
    setTimeout(() => { 
        console.log(fileArr);
        fileArr.forEach(e => {
            useArr.push({
                ...baseConfig,
                entry: entry(e.inputPath),
                plugins: [
                    new FixStyleOnlyEntriesPlugin(),
                    new MiniCssExtractPlugin({
                        filename: e.outputPath+'/[name].css' //css打包输出出口及文件名称
                    })
                ],
            })
        });

        resolve(useArr)
        
    }, 5000);
})
